//////////////////////////////////////////////////////////////////////////
// Program: 		Numero 1.0
// Author:			Tuukka Lehtinen
// State:			Its wont crash.
// Creation Date: 	10 Feb 2003
// Description:   	Numero is simple calculator. It's won't win
//					TI-89, but its don't eat batters. Btw before
//					some one ask numero mean number :)
//
// Notes:			This example won't be compile under unicode in LCC
//                  Becose Microsoft isin't are ported atof to support
//                  unicode. However its works under BCC.
//                  And it is quick compiled using also MinGW.
//////////////////////////////////////////////////////////////////////////
#define _WIN32_IE  0x0400
#include <windows.h>	// basic windows stuff
#include <windowsx.h>	// macros WM_GET_MENU this case
#include <commctrl.h>	// for status bar
#include <tchar.h>		// for _T macro
#include <stdio.h>		// sprintf()
#include <math.h>		// uses pow() and fmod()
#include "numerores.h"

//////////////////////////////////////////////////////////////////////////
// Defines
//////////////////////////////////////////////////////////////////////////
#define BUFSIZE 100		// generally buffer size
#define IDM_INPUTBOX 2000
#define IDM_RESULT   2010
#define NOPS 9			// Number of supported operators

#ifndef _ttof
#define _ttof           atof
#endif

//////////////////////////////////////////////////////////////////////////
// Datatypes
//////////////////////////////////////////////////////////////////////////
struct Oper
{
  char ident;
  int order;
};

//////////////////////////////////////////////////////////////////////////
// Global variables
//////////////////////////////////////////////////////////////////////////
HINSTANCE 	hInst;			// Instance handle
HWND		hwndMain;		// Main window handle
HWND		hwndStatusbar;	// Statusbar window handle
HWND		hwndInput;		// Input box window handle
HWND		hwndResult;		// Result box window handle
WNDPROC		InputOldProc;

struct Oper operators[] =
{
  { '^', 0 },
  { '*', 1 },
  { '/', 1 },
  { '+', 2 },
  { '-', 2 },
  { '%', 3 },
  { '&', 4 },
  { '|', 4 },
};


//////////////////////////////////////////////////////////////////////////
// Function prototypes
//////////////////////////////////////////////////////////////////////////
LRESULT CALLBACK MainWndProc(HWND,UINT,WPARAM,LPARAM);
BOOL SBarUpdate(LPTSTR szText);
BOOL SBarCreate(HWND hwndParent,LPTSTR szText);
LRESULT MsgMenuSelect(WPARAM,LPARAM);
VOID MainWndProc_OnCommand(HWND,INT,HWND,UINT);
void FatalError(void);
BOOL CreateInputBox(HWND hwndParent);
BOOL CreateResultBox(HWND hwndParent);
LRESULT CALLBACK InputProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);
double Calculate(TCHAR expr[]);
INT Operator(TCHAR oper);

//////////////////////////////////////////////////////////////////////////
// WinMain() Start'Up program
//////////////////////////////////////////////////////////////////////////
#pragma argsused
int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
LPSTR lpCmdLine, INT nCmdShow)
{
	MSG 		msg;
	HANDLE		hAccelTable;
	WNDCLASS	wc;
	BOOL		bRet;
	TCHAR		szAppName[] = _T("Numero");
	INITCOMMONCONTROLSEX ic;
	hInst = hInstance;

	memset(&wc,0,sizeof(WNDCLASS));
	wc.style = CS_HREDRAW|CS_VREDRAW |CS_DBLCLKS ;
	wc.lpfnWndProc = (WNDPROC)MainWndProc;
	wc.hInstance = hInst;
	wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
	wc.lpszClassName = szAppName;
	wc.lpszMenuName = MAKEINTRESOURCE(IDMAINMENU);
	wc.hCursor = LoadCursor(NULL,IDC_ARROW);
	wc.hIcon = LoadIcon(NULL,IDI_APPLICATION);
	if (!RegisterClass(&wc))
		FatalError();

	hwndMain = CreateWindow(szAppName, szAppName,
		WS_OVERLAPPEDWINDOW, CW_USEDEFAULT,0,CW_USEDEFAULT,0,
		NULL, NULL, hInst, NULL);
	if(hwndMain == NULL)
		FatalError();

	ic.dwSize = sizeof(INITCOMMONCONTROLSEX);
	ic.dwICC = ICC_BAR_CLASSES;
	if(!InitCommonControlsEx(&ic))
		FatalError();

	hAccelTable = LoadAccelerators(hInst,MAKEINTRESOURCE(IDACCEL));
	if(hAccelTable == NULL)
		FatalError();

	if(!SBarCreate(hwndMain,_T("Ready")))
		FatalError();

	// show window return only previos state -> no error checking.
	ShowWindow(hwndMain,nCmdShow);

	while( (bRet = GetMessage( &msg, NULL, 0, 0 )) != 0)
	{
		if(bRet == -1) FatalError();

		if(!TranslateAccelerator(msg.hwnd,hAccelTable,&msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	return msg.wParam;
}

//////////////////////////////////////////////////////////////////////////
// SBarUpdate - Update status bar text to new one.
// Return: True if success.
//////////////////////////////////////////////////////////////////////////
BOOL SBarUpdate(LPTSTR szText)
{
	return SendMessage(hwndStatusbar, SB_SETTEXT, 0, (LPARAM) szText);
}

//////////////////////////////////////////////////////////////////////////
// SBarUpdate - Update status bar text to new one.
// Return: True if success.
//////////////////////////////////////////////////////////////////////////
BOOL SBarCreate(HWND hwndParent,LPTSTR szText)
{
//    hwndStatusbar = CreateStatusWindow(
//		WS_CHILD | WS_VISIBLE | WS_BORDER | SBARS_SIZEGRIP,
//    	szText, hwndParent, IDM_STATUSBAR);
	hwndStatusbar = CreateWindowEx(0,
		STATUSCLASSNAME,
		_T(""), 					// no window title
		WS_CHILD | WS_VISIBLE | SBARS_SIZEGRIP,	// styles
		0, 0, 0, 0,					// set size to WM_SIZE message
		hwndParent,					// parent window
		(HMENU) IDM_STATUSBAR,		// edit control ID
		hInst,						// instance
		NULL);						// pointer not needed


	if(hwndStatusbar)
		return TRUE;
	else
		return FALSE;
}

//////////////////////////////////////////////////////////////////////////
// MsgMenuSelect - Show help string in statusbar when user browse menu.
// Return: ?
//////////////////////////////////////////////////////////////////////////
LRESULT MsgMenuSelect(WPARAM wparam, LPARAM lparam)
{
    static TCHAR szBuffer[BUFSIZE];
    UINT   nStringID;
    UINT   fuFlags = GET_WM_MENUSELECT_FLAGS(wparam, lparam) & 0xffff;
    UINT   uCmd    = GET_WM_MENUSELECT_CMD(wparam, lparam);
    HMENU  hMenu   = GET_WM_MENUSELECT_HMENU(wparam, lparam);

    szBuffer[0] = 0;                            // First reset the buffer
    if (fuFlags == 0xffff && hMenu == NULL)     // Menu has been closed
        nStringID = 0;

    else if (fuFlags & MFT_SEPARATOR)           // Ignore separators
        nStringID = 0;

    else if (fuFlags & MF_POPUP)                // Popup menu
    {
        if (fuFlags & MF_SYSMENU)               // System menu
            nStringID = IDS_SYSMENU;
        else
            // Get string ID for popup menu from idPopup array.
            nStringID = 0;
    }  // for MF_POPUP
    else                                        // Must be a command item
        nStringID = uCmd;                       // String ID == Command ID

    // Load the string if we have an ID
    if (0 != nStringID)
        LoadString(hInst, nStringID, szBuffer, sizeof(szBuffer));

    // Finally... send the string to the status bar
	if(!SBarUpdate(szBuffer))
		FatalError();

    return 0;
}

//////////////////////////////////////////////////////////////////////////
// MainWndProc_OnCommand - Handle all menu commands
//////////////////////////////////////////////////////////////////////////
#pragma argsused
void MainWndProc_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
	LPTSTR p;
	INT index;

	switch(id)
	{
		case IDM_RESULT:
		{
			if(codeNotify == LBN_DBLCLK)
			{
				LONG lResult;

				index = SendMessage(hwndResult, LB_GETCURSEL, 0,0);
				if(index != LB_ERR)
				{
					lResult = SendMessage(hwndResult, LB_GETTEXTLEN, index, 0);
					if(lResult == LB_ERR) FatalError();
					p = malloc((lResult + 1) * sizeof(TCHAR));
					if(p == NULL) FatalError();
					lResult = SendMessage(hwndResult, LB_GETTEXT, index, (LPARAM) p);
					if(lResult == LB_ERR) FatalError();
					if(!SetWindowText(hwndInput, p))
						FatalError();
					free(p);
				}
			}
		}
		break;


		case IDM_EXIT:
			if(!PostMessage(hwnd,WM_CLOSE,0,0))
				FatalError();
		break;

		case IDM_ABOUT:
		{
			TCHAR msg[100];

			if(_stprintf(msg, _T("%s\n%s%s %s"), _T("Numero - simple calculator!"),_T("Compiled: "),
		    	_T("__DATE__"), _T("__TIME__")) < 0)
				FatalError();

			if(0 == MessageBox(hwndMain, msg, _T("About"), MB_OK))
				FatalError();
		}
	}
}

//////////////////////////////////////////////////////////////////////////
// MainWndProc handle all general messages.
//////////////////////////////////////////////////////////////////////////
LRESULT CALLBACK MainWndProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
	static INT cyChar;

	switch (msg)
	{

	case WM_SETFOCUS:
		// We don't check error becose this can couses to program crash
		// error in same time if some other program get focus using
		// example MessageBox().
		SetFocus(hwndInput);
	break;

	case WM_CREATE:
		cyChar = HIWORD (GetDialogBaseUnits ());
		if(!CreateInputBox(hwnd))
			FatalError();
		if(!CreateResultBox(hwnd))
			FatalError();
	break;

	case WM_SIZE:
	{
		RECT rect;
		INT  i;

		SendMessage(hwndStatusbar,msg,wParam,lParam);
		if(!GetClientRect(hwndStatusbar, &rect))
			FatalError();

		i = HIWORD(lParam) - (rect.bottom - rect.top) - (5 * cyChar / 4);
		if(!MoveWindow(hwndInput, rect.left, i, rect.right, rect.bottom, TRUE))
			FatalError();
		if(!GetClientRect(hwndInput, &rect))
			FatalError();
		if(!MoveWindow(hwndResult, 0, 0, rect.right, i, TRUE))
			FatalError();
	}
	break;

	case WM_MENUSELECT:
	return MsgMenuSelect(wParam,lParam);

	case WM_COMMAND:
	return HANDLE_WM_COMMAND(hwnd,wParam,lParam,MainWndProc_OnCommand);

	case WM_DESTROY:
		// void function.
		PostQuitMessage(0);
	break;

	default:
		return DefWindowProc(hwnd,msg,wParam,lParam);
	}
	return 0;
}

//////////////////////////////////////////////////////////////////////////
// FatalError()
// Generate error message using GetLastErro & FormatMessage system and
// quit system using ExitProcess(1);
//////////////////////////////////////////////////////////////////////////
void FatalError(void)
{
	LPVOID lpMsgBuf;
	DWORD dw;

	dw = FormatMessage(
    	FORMAT_MESSAGE_ALLOCATE_BUFFER |
	    FORMAT_MESSAGE_FROM_SYSTEM |
    	FORMAT_MESSAGE_IGNORE_INSERTS,
    	NULL,
    	GetLastError(),
    	MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
    	(LPTSTR) &lpMsgBuf,
    	0,
    	NULL );

	if(dw)
	{
		MessageBox( hwndMain, (LPCTSTR)lpMsgBuf, _T("Numero - Error"),
			MB_OK | MB_ICONINFORMATION );
		// Free the buffer.
		LocalFree( lpMsgBuf );
	}
	ExitProcess(1);
}

//////////////////////////////////////////////////////////////////////////
// CreateInputBox()
// Create EDIT control where user can insert calculations.
//////////////////////////////////////////////////////////////////////////
BOOL CreateInputBox(HWND hwndParent)
{
	hwndInput = CreateWindow(
		_T("EDIT"),				// predefined class
		_T(""), 				// no window title
		WS_CHILD | WS_VISIBLE | WS_BORDER,	// styles
		0, 0, 0, 0,				// set size to WM_SIZE message
		hwndParent,				// parent window
		(HMENU) IDM_INPUTBOX,	// edit control ID
		hInst,					// instance
		NULL);					// pointer not needed

	InputOldProc = (WNDPROC) SetWindowLong (hwndInput, GWL_WNDPROC, (LONG) InputProc);

	if(hwndInput == NULL)
		return FALSE;
	else
		return TRUE;
}

//////////////////////////////////////////////////////////////////////////
// CreateResultBox()
// Use ListBox to show difrent type of results.
//////////////////////////////////////////////////////////////////////////
BOOL CreateResultBox(HWND hwndParent)
{
	hwndResult = CreateWindow(
		_T("LISTBOX"),				// predefined class
		_T(""), 					// no window title
		WS_CHILD | WS_VISIBLE | LBS_NOTIFY | WS_VSCROLL ,	// styles
		0, 0, 0, 0,					// set size to WM_SIZE message
		hwndParent,					// parent window
		(HMENU) IDM_RESULT,			// edit control ID
		hInst,						// instance
		NULL);						// pointer not needed

	if(hwndInput == NULL)
		return FALSE;
	else
		return TRUE;
}

void OutOfSpace(void)
{
	if(0 == MessageBox(hwndMain, _T("Out of space to store number or formula!"),
   	 _T("Error"), MB_OK))
	FatalError();
}

//////////////////////////////////////////////////////////////////////////
// InputProc()
// Used by EDIT control to catch pressed enter button.
//////////////////////////////////////////////////////////////////////////
LRESULT CALLBACK InputProc (HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	TCHAR szBuf[256];
	double d;
	LONG lResult;

	if(msg == WM_KEYDOWN && wParam == VK_RETURN)
	{
		// GetWindowText will fail if user isin't are writed nothing.
		if(!GetWindowText(hwndInput, szBuf, sizeof(szBuf)/sizeof(TCHAR)))
			return 0;

		lResult = SendMessage(hwndResult, LB_ADDSTRING, 0, (LPARAM) szBuf);
		if(lResult == LB_ERR) FatalError();
		if(lResult == LB_ERRSPACE)
		{
			OutOfSpace();
			return 0;
		}

		d = Calculate(szBuf);

		if(_stprintf(szBuf, _T("%g"), d) < 0)
			FatalError();
		lResult = SendMessage(hwndResult, LB_ADDSTRING, 0, (LPARAM) szBuf);
		if(lResult == LB_ERR) FatalError();
		if(lResult == LB_ERRSPACE)
		{
			OutOfSpace();
			return 0;
		}

		if(!SetWindowText(hwndInput, _T("")))
				FatalError();
	}

	// Eny other messages goes editbox
	return CallWindowProc (InputOldProc, hwnd, msg, wParam, lParam) ;
}

//////////////////////////////////////////////////////////////////////////
// Calculate
// Try to calculate user entered string.
//////////////////////////////////////////////////////////////////////////
double Calculate(TCHAR expr[])
{
	unsigned int i;
	int braces = 0, minbraces = -1;
	int lastop = -1, numops = 0;
	double a, b, c = 0;
	unsigned int len;
	LPTSTR pa;
	LPTSTR pb;

	len = _tcslen(expr);

	// count ()
	for(i = 0; i < len; i++)
	{
		char c = expr[i];
		if(c - 32)
		{
			if     (c == '(') braces++;
			else if(c == ')') braces--;
			else if(braces <= minbraces || minbraces == -1)
				minbraces = braces;
		}
	}

	// Find last proceeded operator
	for(i = 0, braces = 0; i < len; i++)
	{
		char c = expr[i];
		if     (c == '(') braces++;
		else if(c == ')') braces--;
		else if(Operator(c) != -1)
		{
			numops++;
			if(braces == minbraces)
			{
				lastop = i;
			}
		}
	}

	// Not operatos -> only number -> return
	if(!numops)
	{
		for(i = 0; i < len && !isdigit(expr[i]); i++);
		return _ttof(expr);
	}

	// Continue solving in recursive
	pa = malloc((_tcslen(expr) - lastop) * sizeof(TCHAR));
	if(pa == NULL) FatalError();
	_tcsncpy(pa, expr, lastop);
	a = Calculate(pa);
	free(pa);

	pa = malloc( (_tcslen(expr - lastop)) * sizeof(TCHAR));
	if(pa == NULL) FatalError();
	pb = &expr[lastop+1];
	_tcscpy(pa, pb);
	b = Calculate(pa);
	free(pa);

	// Make actual counting
	switch(expr[lastop])
	{
		case '&': c = (int)a & (int)b; break;
		case '|': c = (int)a | (int)b; break;
		case '+': c = a + b; break;
		case '-': c = a - b; break;
		case '*': c = a * b; break;
		case '/': c = a / b; break;
		case '^': c = pow(a, b); break;
		case '%': c = fmod(a, b); break;
	}

  return c;
}

//////////////////////////////////////////////////////////////////////////
// opOrder
// Check is charter operator or not.
//////////////////////////////////////////////////////////////////////////
INT Operator(TCHAR oper)
{
	INT i;

	for(i = 0; i < NOPS; i++)
		if(operators[i].ident == oper)
			return operators[i].order;
	return -1;
}
